(* Time-stamp: <modified the 03/10/2014 (at 11:17) by Erwan Jahier> *)


(** Choose between the various C code generators (heap-based, Stack
    based, etc).

    the "Dep" in the module name means "Depends", but I'm not happy
    with this name...  *)


(* [gen_assign t vi vo size] generated the C code that assign vo to vi,
   using memcpy or = depending on the type t *)
val gen_assign : Data.t  -> string -> string -> string -> string

(* ditto *)
val gen_assign_var_expr : Soc.t -> Soc.var_expr -> Soc.var_expr -> string

(* Generates the C step name from the soc key and the soc step name *)
val step_name : Soc.key -> string -> string

val string_of_var_expr: Soc.t -> Soc.var_expr -> string


(* [ctx_var vk id] *)
val ctx_var : Soc2cUtil.var_kind -> Ident.t -> string
  
(*  [gen_step_call soc called_soc vel_out vel_in ctx sname step_arg]
 Generates the C code that performs the call to a step method of
   [called_soc] from [soc].
   - [vel_out] and [vel_in] are the called_soc O/I arguments
   - [ctx] is the C name of the context of the called_soc
   - [sname] is the C name of the step to call
   - [step_arg] is a string holding the arg of the step (empty for proc call)
*)

val gen_step_call : Soc.t -> Soc.t -> Soc.var_expr list -> Soc.var_expr list -> 
     string -> string -> string -> string
(* should this soc be inlined? (depends on Lv6MainArgs.global_opt) *)
val inlined_soc : Soc.t -> bool

(** Returns the C code corresponding a soc key  *)
val get_predef_op: Soc.key -> string

(** Returns the C code implementing an iterator (map, fill, red) *)
val get_iterator : Soc.t -> string ->  Soc.t ->  int -> string


(** Returns the C code implementing a condact *)
val get_condact : Soc.t -> Soc.t -> Soc.var_expr list -> string 

(** Returns the C code implementing a boolred *)
val get_boolred : Soc.t -> int -> int -> int -> string 


